
#include "kolibri.h"
#include "stdlib.h"
#include "string.h"

#include "all.h"

#include "console.c"

#define SHELL_VERSION "0.2"
#define SHELL_DATE "01.08.2008"

extern char PATH[256];

char title[64];
char command[256];
char cur_dir[256];

/// ===========================================================

#include "cmd_about.c"
#include "cmd_help.c"
#include "cmd_ver.c"
#include "cmd_pwd.c"
#include "cmd_ls.c"
#include "cmd_ps.c"
#include "cmd_kill.c"
#include "cmd_echo.c"
#include "cmd_date.c"
#include "cmd_exec.c"
#include "cmd_exit.c"
#include "cmd_cd.c"
#include "cmd_free.c"
#include "cmd_reboot.c"
#include "cmd_mkdir.c"
#include "cmd_rmdir.c"
#include "cmd_rm.c"
#include "cmd_touch.c"

#include "command_get.c"

/// ===========================================================

int dir_check(char dir[])
{
kol_struct70	k70;
int		result;

k70.p00 = 1;
k70.p04 = 0;
k70.p08 = 0;
k70.p12 = 1024*1024; // 1 MB
k70.p16 = malloc(1024*1024);
k70.p20 = 0;
k70.p21 = dir;

result = kol_file_70(&k70);

free(k70.p16);

return result;
}

/// ===========================================================

void dir_truncate(char dir[])
{
int i;
i = strlen(dir)-1;
for (;;i--)
	if ('/' == dir[i])
		{
		dir[i+1] = 0;
		break;
		}
}

/// ===========================================================

int file_check(char file[])
{
kol_struct70	k70;
int		result;

k70.p00 = 0;
k70.p04 = 0;
k70.p08 = 0;
k70.p12 = 0;
k70.p16 = 0;
k70.p20 = 0;
k70.p21 = file;

result = kol_file_70(&k70);

return result;
}

/// ===========================================================

int iswhite(char c)
{
return ((' ' == c) || ('\t' == c) || (13 == c) || (10 == c));
}

/// ===========================================================

void trim(char string[])
{
int i, j;

for (i=0; ;i++)
	if ( !iswhite(string[i]) )
		break;
j = 0;
for (;;i++, j++)
	{
	string[j] = string[i];
	if ('\0' == string[i] )
		break;
	}

for (i=0; ;i++)
	if ('\0' == string[i])
		break;
i--;
for (;i>0;--i)
	if ( iswhite(string[i]) )
		string[i] = '\0';
	else
		break;
}

/// ===========================================================

unsigned getcmd(char cmd[])
{
unsigned i;
for (i=0;;i++)
	{
	cmd[i]=command[i];
	if (0 == cmd[i])
		{
//		cmd[i-1]=0;
		i = -2;
		break;
		}
	if ( iswhite(cmd[i]) )
		{
		cmd[i] = 0;
		break;
		}
	}
return i+1;
}

/// ===========================================================

void execute()
{
char cmd[256];
char args[256];
unsigned arg;

trim(command);
arg = getcmd(cmd);

if ( !strlen(cmd) )
	return;

strcpy(args, command+arg);
trim(args);

if ( !strcmp(cmd, "help") )
	{
	if (-1 == arg)
		cmd_help(NULL);
	else
		cmd_help(args);
	return;
	}

if ( !strcmp(cmd, "ver") )
	{
	cmd_ver();
	return;
	}

if ( !strcmp(cmd, "cd") )
	{
	if (-1 == arg)
		cmd_cd(NULL);
	else
		cmd_cd(args);

	if ( '/' != cur_dir[strlen(cur_dir)-1] )
		strcat(cur_dir, "/");

	return;
	}

if ( !strcmp(cmd, "ls") )
	{
	if (-1 == arg)
		cmd_ls(cur_dir);
	else 
		cmd_ls(args);
	return;
	}

if ( !strcmp(cmd, "ps") )
	{
	cmd_ps();
	return;
	}

if ( !strcmp(cmd, "kill") )
	{
	if (-1 == arg)
		cmd_kill(NULL);
	else
		cmd_kill(args);
	return;
	}

if ( !strcmp(cmd, "pwd") )
	{
	cmd_pwd();
	return;
	}

if ( !strcmp(cmd, "mkdir") )
	{
	if (-1 == arg)
		cmd_mkdir(NULL);
	else
		cmd_mkdir(args);
	return;
	}

if ( !strcmp(cmd, "rmdir") )
	{
	if (-1 == arg)
		cmd_rmdir(NULL);
	else
		cmd_rmdir(args);
	return;
	}

if ( !strcmp(cmd, "rm") )
	{
	if (-1 == arg)
		cmd_rm(NULL);
	else
		cmd_rm(args);
	return;
	}

if ( !strcmp(cmd, "echo") )
	{
	cmd_echo(args);
	return;
	}

if ( !strcmp(cmd, "exit") )
	{
	cmd_exit();
	return;
	}

if ( !strcmp(cmd, "date") )
	{
	cmd_date();
	return;
	}

if ( !strcmp(cmd, "about") )
	{
	cmd_about();
	return;
	}

if ( !strcmp(cmd, "free") )
	{
	cmd_free();
	return;
	}

if ( !strcmp(cmd, "reboot") )
	{
	cmd_reboot();
	return;
	}

if ( !strcmp(cmd, "touch") )
	{
	if (-1 == arg)
		cmd_touch(NULL);
	else
		cmd_touch(args);
	return;
	}

cmd_exec(cmd, args);

}

/// ===========================================================

void kol_main()
{

strcpy(title, "SHELL ");
strcat(title, SHELL_VERSION);
CONSOLE_INIT(title);

strcpy(cur_dir, PATH);
dir_truncate(cur_dir);

con_set_cursor_height(con_get_font_height()-1);
//con_set_flags(CON_COLOR_GREEN | CON_COLOR_BRIGHT);

cmd_about();
printf("Type \'help\' for help.\n\r\n\r");

for (;;)
	{
	printf ("# ");
	//gets(command, 256);
	command_get();
	execute();
	}

_exit(0);
kol_exit();
}

/// ===========================================================
